package jbossbugtest.jboss;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Singleton;
import javax.ejb.Startup;

import jbossbugtest.console.Main;
import org.slf4j.LoggerFactory;

// THE ERROR (read description for additional info at end of this log output):
//
// 19:43:02,753 INFO  [org.jboss.as.server.deployment] (MSC service thread 1-2) JBAS015876: Starting deployment of "jbosstest.javaproject-0.0.1-SNAPSHOT.jar"
// 19:43:02,800 INFO  [org.jboss.as.ejb3.deployment.processors.EjbJndiBindingsDeploymentUnitProcessor] (MSC service thread 1-2) JNDI bindings for session bean named ModuleMain in deployment unit deployment "jbosstest.javaproject-0.0.1-SNAPSHOT.jar" are as follows:
// 
//         java:global/jbosstest.javaproject-0.0.1-SNAPSHOT/ModuleMain!java.lang.Runnable
//         java:app/jbosstest.javaproject-0.0.1-SNAPSHOT/ModuleMain!java.lang.Runnable
//         java:module/ModuleMain!java.lang.Runnable
//         java:global/jbosstest.javaproject-0.0.1-SNAPSHOT/ModuleMain
//         java:app/jbosstest.javaproject-0.0.1-SNAPSHOT/ModuleMain
//         java:module/ModuleMain
// 
// 19:43:02,830 ERROR [org.jboss.msc.service.fail] (MSC service thread 1-2) MSC00001: Failed to start service jboss.deployment.unit."jbosstest.javaproject-0.0.1-SNAPSHOT.jar".INSTALL: org.jboss.msc.service.StartException in service jboss.deployment.unit."jbosstest.javaproject-0.0.1-SNAPSHOT.jar".INSTALL: Failed to process phase INSTALL of deployment "jbosstest.javaproject-0.0.1-SNAPSHOT.jar"
//         at org.jboss.as.server.deployment.DeploymentUnitPhaseService.start(DeploymentUnitPhaseService.java:119) [jboss-as-server-7.1.1.Final.jar:7.1.1.Final]
//         at org.jboss.msc.service.ServiceControllerImpl$StartTask.startService(ServiceControllerImpl.java:1811) [jboss-msc-1.0.2.GA.jar:1.0.2.GA]
//         at org.jboss.msc.service.ServiceControllerImpl$StartTask.run(ServiceControllerImpl.java:1746) [jboss-msc-1.0.2.GA.jar:1.0.2.GA]
//         at java.util.concurrent.ThreadPoolExecutor$Worker.runTask(ThreadPoolExecutor.java:886) [rt.jar:1.6.0_33]
//         at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:908) [rt.jar:1.6.0_33]
//         at java.lang.Thread.run(Thread.java:662) [rt.jar:1.6.0_33]
// Caused by: org.jboss.as.server.deployment.DeploymentUnitProcessingException: JBAS011030: Could not configure component ModuleMain
//         at org.jboss.as.ee.component.deployers.EEModuleConfigurationProcessor.deploy(EEModuleConfigurationProcessor.java:92)
//         at org.jboss.as.server.deployment.DeploymentUnitPhaseService.start(DeploymentUnitPhaseService.java:113) [jboss-as-server-7.1.1.Final.jar:7.1.1.Final]
//         ... 5 more
// Caused by: java.lang.RuntimeException: java.lang.reflect.InvocationTargetException
//         at org.jboss.classfilewriter.ClassFile.define(ClassFile.java:280)
//         at org.jboss.invocation.proxy.AbstractClassFactory.defineClass(AbstractClassFactory.java:164)
//         at org.jboss.invocation.proxy.AbstractProxyFactory.getCachedMethods(AbstractProxyFactory.java:145)
//         at org.jboss.as.ejb3.component.singleton.SingletonComponentDescription$4.configure(SingletonComponentDescription.java:183)
//         at org.jboss.as.ee.component.ComponentDescription$DefaultComponentConfigurator.configure(ComponentDescription.java:921)
//         at org.jboss.as.ee.component.deployers.EEModuleConfigurationProcessor.deploy(EEModuleConfigurationProcessor.java:81)
//         ... 6 more
// Caused by: java.lang.reflect.InvocationTargetException
//         at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method) [rt.jar:1.6.0_33]
//         at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:39) [rt.jar:1.6.0_33]
//         at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:25) [rt.jar:1.6.0_33]
//         at java.lang.reflect.Method.invoke(Method.java:597) [rt.jar:1.6.0_33]
//         at org.jboss.classfilewriter.ClassFile.define(ClassFile.java:275)
//         ... 11 more
// Caused by: java.lang.SecurityException: Prohibited package name: java.lang
//         at java.lang.ClassLoader.preDefineClass(ClassLoader.java:479) [rt.jar:1.6.0_33]
//         at java.lang.ClassLoader.defineClassCond(ClassLoader.java:625) [rt.jar:1.6.0_33]
//         at java.lang.ClassLoader.defineClass(ClassLoader.java:615) [rt.jar:1.6.0_33]
//         ... 16 more
// 
// 19:43:03,087 INFO  [org.jboss.as.server] (DeploymentScanner-threads - 2) JBAS015870: Deploy of deployment "jbosstest.javaproject-0.0.1-SNAPSHOT.jar" was rolled back with failure message {"JBAS014671: Failed services" => {"jboss.deployment.unit.\"jbosstest.javaproject-0.0.1-SNAPSHOT.jar\".INSTALL" => "org.jboss.msc.service.StartException in service jboss.deployment.unit.\"jbosstest.javaproject-0.0.1-SNAPSHOT.jar\".INSTALL: Failed to process phase INSTALL of deployment \"jbosstest.javaproject-0.0.1-SNAPSHOT.jar\""},"JBAS014771: Services with missing/unavailable dependencies" => ["jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ValidatorFactoryjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ValidatorFactoryjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]","jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ORBjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ORBjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]","jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.HandleDelegatejboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.HandleDelegatejboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]","jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.Validatorjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.Validatorjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]"]}
// 19:43:03,109 INFO  [org.jboss.as.server.deployment] (MSC service thread 1-1) JBAS015877: Stopped deployment jbosstest.javaproject-0.0.1-SNAPSHOT.jar in 22ms
// 19:43:03,137 INFO  [org.jboss.as.controller] (DeploymentScanner-threads - 2) JBAS014774: Service status report
// JBAS014775:    New missing/unsatisfied dependencies:
//       service jboss.naming.context.java.comp."jbosstest.javaproject-0.0.1-SNAPSHOT"."jbosstest.javaproject-0.0.1-SNAPSHOT".ModuleMain (missing) dependents: [service jboss.naming.context.java.comp."jbosstest.javaproject-0.0.1-SNAPSHOT"."jbosstest.javaproject-0.0.1-SNAPSHOT".ModuleMain.ORB, service jboss.naming.context.java.comp."jbosstest.javaproject-0.0.1-SNAPSHOT"."jbosstest.javaproject-0.0.1-SNAPSHOT".ModuleMain.ValidatorFactory, service jboss.naming.context.java.comp."jbosstest.javaproject-0.0.1-SNAPSHOT"."jbosstest.javaproject-0.0.1-SNAPSHOT".ModuleMain.HandleDelegate, service jboss.naming.context.java.comp."jbosstest.javaproject-0.0.1-SNAPSHOT"."jbosstest.javaproject-0.0.1-SNAPSHOT".ModuleMain.Validator] 
// JBAS014777:   Services which failed to start:      service jboss.deployment.unit."jbosstest.javaproject-0.0.1-SNAPSHOT.jar".INSTALL: org.jboss.msc.service.StartException in service jboss.deployment.unit."jbosstest.javaproject-0.0.1-SNAPSHOT.jar".INSTALL: Failed to process phase INSTALL of deployment "jbosstest.javaproject-0.0.1-SNAPSHOT.jar"
// 
// 19:43:03,153 ERROR [org.jboss.as.server.deployment.scanner] (DeploymentScanner-threads - 1) {"JBAS014653: Composite operation failed and was rolled back. Steps that failed:" => {"Operation step-2" => {"JBAS014671: Failed services" => {"jboss.deployment.unit.\"jbosstest.javaproject-0.0.1-SNAPSHOT.jar\".INSTALL" => "org.jboss.msc.service.StartException in service jboss.deployment.unit.\"jbosstest.javaproject-0.0.1-SNAPSHOT.jar\".INSTALL: Failed to process phase INSTALL of deployment \"jbosstest.javaproject-0.0.1-SNAPSHOT.jar\""},"JBAS014771: Services with missing/unavailable dependencies" => ["jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ValidatorFactoryjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ValidatorFactoryjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]","jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ORBjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.ORBjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]","jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.HandleDelegatejboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.HandleDelegatejboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]","jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.Validatorjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMainMissing[jboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain.Validatorjboss.naming.context.java.comp.\"jbosstest.javaproject-0.0.1-SNAPSHOT\".\"jbosstest.javaproject-0.0.1-SNAPSHOT\".ModuleMain]"]}}}
// 
//
// To test the bug issue.
//
//  Good scenarios that do not trigger the problem:
//    Both implements Runnable,LifecycleListener
//    Just implements LifecycleListener
//
//  Bad scenarios that DO tigger the problem:
//    Just implements Runnable
//
//  So try simply changing the class definition info about
//    5 lines below.  This change in behaviour alone suggests
//    a bug exists.
// 
@Startup
@Singleton
public class ModuleMain implements Runnable /*, LifecycleListener*/ {
	private ModuleMainThread moduleMainThread;
	private Thread thread;
	private boolean terminated;

	private static final org.slf4j.Logger log = LoggerFactory.getLogger(ModuleMain.class);

	@PostConstruct
	public void init() {
		log.info("init()");
		start();
	}

	public void start() {
		log.info("start() BEGIN");
		try {
			cleanupCheck();

			synchronized (this) {
				if(thread != null)
					return;
				terminated = false;
				Class<?> impl;
				if(this instanceof Runnable) {
					// Using this directly
					thread = new Thread(this);
					impl = ModuleMainThread.class;
				} else {
					// Ok usage in a different class
					if(this instanceof LifecycleListener)
						moduleMainThread = new ModuleMainThread((LifecycleListener)this);
					else
						moduleMainThread = new ModuleMainThread(null);
					thread = new Thread(moduleMainThread);
					impl = ModuleMainThread.class;
				}
				thread.setName(impl.getName());
				thread.start();
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
		log.info("start() END");
	}

	private boolean cleanupCheck() {
		synchronized (this) {
			if(moduleMainThread == null && thread == null)
				return true;
			if(terminated) {
				moduleMainThread = null;
				thread = null;
				return true;
			}
		}
		return false;
	}

	private boolean waitForTerminated(long millis) {
		log.info("waitForTerminated() BEGIN");
		if(millis < 0)
			millis = 0;
		long expire = System.currentTimeMillis() + millis;
		boolean bf = false;
		while(true) {
			synchronized (this) {
				if((bf = cleanupCheck()))
					break;
				long timeout = expire - System.currentTimeMillis();
				if(timeout <= 0)
					break;
				try {
					this.wait(timeout);
				} catch (InterruptedException e) {
					break;
				}
			}
		}
		log.info("waitForTerminated() DONE");
		return bf;
	}

	@PreDestroy
	public void stop() {
		log.info("stop() BEGIN");
		ModuleMainThread thisModuleMainThread = moduleMainThread;
		if(thisModuleMainThread != null) {
			thisModuleMainThread.signal(Main.SIGNAL_EXIT);
			waitForTerminated(10000);
			cleanupCheck();
		}
		log.info("stop() DONE");
	}

	public void terminated(Object result) {
		synchronized (this) {
			terminated = true;
			this.notifyAll();
		}
	}

	public void run() {
		log.info("RUNNABLE RUN stop() BEGIN");
		// We check instanceof as I was testing what triggered the bug
		// since with 2 interfaces defined all was ok
		if(this instanceof LifecycleListener)
			moduleMainThread = new ModuleMainThread((LifecycleListener)this);
		else
			moduleMainThread = new ModuleMainThread(null);
		moduleMainThread.run();		// delegate
	}
}
